#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/vmalloc.h>

static int __init vmalloc_kernel_module_init(void)
{
  unsigned long i;
  void *ptr;

  printk("vmalloc_kernel_module_init()\n");

  for (i = 1;; i *= 2) {
    ptr = vmalloc(i);

    if (!ptr) {
      printk("Error: cannot allocate %lu bytes\n", i);
      break;
    }

    printk("allocate %lu bytes\n", i);

    vfree(ptr);
  }

  return 0;
}

static void __exit vmalloc_kernel_module_exit(void)
{
  printk("vmalloc_kernel_module_exit()\n");
}

module_init(vmalloc_kernel_module_init);
module_exit(vmalloc_kernel_module_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Hiroyuki Chishiro");
MODULE_DESCRIPTION("Vmalloc Kernel Module");
